"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .errorresponse import ErrorResponse, ErrorResponseTypedDict
from gsmservice_gateway.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from pydantic import model_serializer
from typing import Optional
from typing_extensions import NotRequired, TypedDict


class CancelledMessageTypedDict(TypedDict):
    r"""An object containing information about results of cancelling single message"""

    id: NotRequired[int]
    r"""Message ID"""
    status: NotRequired[int]
    r"""Status of cancellation (204 if cancelled successfully or error status code)"""
    error: NotRequired[Nullable[ErrorResponseTypedDict]]
    r"""An object that complies with RFC 9457 containing information about a request error"""


class CancelledMessage(BaseModel):
    r"""An object containing information about results of cancelling single message"""

    id: Optional[int] = None
    r"""Message ID"""

    status: Optional[int] = None
    r"""Status of cancellation (204 if cancelled successfully or error status code)"""

    error: OptionalNullable[ErrorResponse] = UNSET
    r"""An object that complies with RFC 9457 containing information about a request error"""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["id", "status", "error"]
        nullable_fields = ["error"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
